package org.brynhild.graduation

import android.Manifest
import android.content.Context
import android.content.Intent
import android.content.pm.PackageManager
import android.os.Build
import android.os.Bundle
import android.util.Log
import org.brynhild.graduation.activity.common.BaseActivity
import org.brynhild.graduation.activity.common.LoginActivity
import org.brynhild.graduation.common.config.LoginConfiguration
import org.brynhild.graduation.common.config.MyApplication

class MainActivity : BaseActivity() {
    private var init = false

    fun getPermission() {
        if (Build.VERSION.SDK_INT >= 23) {
            val REQUEST_CODE_CONTACT = 101
            val permissions = arrayOf(Manifest.permission.WRITE_EXTERNAL_STORAGE)
            //验证是否许可权限
            for (str in permissions) {
                if (this.checkSelfPermission(str) != PackageManager.PERMISSION_GRANTED) {
                    //申请权限
                    this.requestPermissions(permissions, REQUEST_CODE_CONTACT)
                }
            }
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
        supportActionBar?.hide()
        loadLoginInfo()
        getPermission()
        tryLogin()
    }

    private fun loadLoginInfo() {
        val sp = getSharedPreferences("account", Context.MODE_PRIVATE)
        val accountName = sp.getString("accountName", "")
        val accountPassword = sp.getString("accountPassword", "")
        LoginConfiguration.login_username = accountName
        LoginConfiguration.login_password = accountPassword
    }

    private fun tryLogin() {
        if (LoginConfiguration.isValid()) {
            LoginConfiguration.login()
        } else {
            val intent = Intent(MyApplication.context, LoginActivity::class.java)
            startActivity(intent)
        }
    }

    override fun onResume() {
        super.onResume()
        Log.d("MainActivity", "Resume...")
        if (init) {
            finish()
        }
        init = true
    }
}