package org.brynhild.graduation.activity.common

import android.os.Bundle
import android.view.LayoutInflater
import org.brynhild.graduation.databinding.ActivityPolicyBinding

class PolicyActivity : BaseActivity() {

    private lateinit var activityPolicyBinding: ActivityPolicyBinding

    companion object {
        const val USER_POLICY = "用户协议"
        const val PRIVACY_POLICY = "隐私政策"
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        activityPolicyBinding = ActivityPolicyBinding.inflate(LayoutInflater.from(this))
        setContentView(activityPolicyBinding.root)
        setSupportActionBar(activityPolicyBinding.toolBar)
        supportActionBar?.let {
            it.title = ""
        }

        activityPolicyBinding.policyTitle.text = intent.getStringExtra("type")

        activityPolicyBinding.policyContent.text = with(StringBuilder()) {
            append("这是协议与政策部分，里面还支持\\n与\\t，例如：\n你好\n\t一级标题：\n\t\t二级标题\n")
            repeat(1000) {
                append(intent.getStringExtra("type"))
            }
            toString()
        }

        activityPolicyBinding.backButton.setOnClickListener {
            finish()
        }
    }
}