package org.brynhild.graduation.common.constant

import android.os.Environment
import java.io.File

object FileStorageConstant {
    private val ROOT_PATH =
        "${Environment.getExternalStorageDirectory().absolutePath}" + File.separator + "FinalProject"

    //TODO 服务器文件上传下载的路径
    private val SERVER_UPLOAD_PATH = "http://192.168.137.1:8100/file/upload/single"
    private val SERVER_DOWNLOAD_PATH_ID = "http://192.168.137.1:8100/file/download/id/"
    const val BASE_URL = "http://192.168.137.1:8100/"

    private val PICTURE_PATH = "$ROOT_PATH${File.separator}Pictures"
    private val VIDEO_PATH = "$ROOT_PATH${File.separator}Videos"

    fun getNewPicturePath(name: String): String {
        initStorage()
        return PICTURE_PATH + File.separator + name
    }

    fun getNewVideoPath(name: String): String {
        initStorage()
        return VIDEO_PATH + File.separator + name
    }

    fun getServerUploadPath(): String {
        return SERVER_UPLOAD_PATH
    }

    fun getServerDownloadPathById(id: Int): String {
        return SERVER_DOWNLOAD_PATH_ID + id
    }

    fun initStorage() {
        val storagePath = listOf(ROOT_PATH, PICTURE_PATH, VIDEO_PATH)
        for (path in storagePath) {
            val file = File(path)
            if (!file.exists()) {
                file.mkdirs()
            }
        }
    }
}