package org.brynhild.graduation.network.adapter

import android.content.Context
import android.content.Intent
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.bumptech.glide.Glide
import com.google.gson.Gson
import org.brynhild.graduation.R
import org.brynhild.graduation.activity.admin.AcademyDetailInfoActivity
import org.brynhild.graduation.common.config.MyApplication
import org.brynhild.graduation.network.entiity.Academy

class AcademyAdapter(private val context: Context, private val academyList: List<Academy>) :
    RecyclerView.Adapter<AcademyAdapter.ViewHolder>() {

    inner class ViewHolder(view: View) : RecyclerView.ViewHolder(view) {
        val avatar: ImageView = view.findViewById(R.id.avatar)
        val name: TextView = view.findViewById(R.id.name)
        val no: TextView = view.findViewById(R.id.no)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.academy_item, parent, false)
        val holder = ViewHolder(view)
        holder.itemView.setOnClickListener {
            val position = holder.adapterPosition
            val academy = academyList[position]
            val intent = Intent(MyApplication.context, AcademyDetailInfoActivity::class.java)
            intent.flags = Intent.FLAG_ACTIVITY_NEW_TASK
            val gson = Gson()
            intent.putExtra("academy", gson.toJson(academy))
            MyApplication.context.startActivity(intent)
        }
        return holder
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val user = academyList[position]
        holder.name.text = user.name
        holder.no.text = user.no
        Glide.with(context).load(user.avatar ?: R.drawable.nav_academy).into(holder.avatar)
    }

    override fun getItemCount() = academyList.size
}