package org.brynhild.graduation.network.adapter

import android.content.Context
import android.content.Intent
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.google.gson.Gson
import org.brynhild.graduation.R
import org.brynhild.graduation.activity.admin.AreaDetailInfoActivity
import org.brynhild.graduation.common.config.MyApplication
import org.brynhild.graduation.network.entiity.Area

class AreaAdapter(private val context: Context, private val areaList: List<Area>) :
    RecyclerView.Adapter<AreaAdapter.ViewHolder>() {

    inner class ViewHolder(view: View) : RecyclerView.ViewHolder(view) {
        val name: TextView = view.findViewById(R.id.name)
        val owner: TextView = view.findViewById(R.id.owner)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.area_item, parent, false)
        val holder = ViewHolder(view)
        holder.itemView.setOnClickListener {
            val position = holder.adapterPosition
            val classEntity = areaList[position]
            val intent = Intent(MyApplication.context, AreaDetailInfoActivity::class.java)
            intent.flags = Intent.FLAG_ACTIVITY_NEW_TASK
            val gson = Gson()
            intent.putExtra("area", gson.toJson(classEntity))
            MyApplication.context.startActivity(intent)
        }
        return holder
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val user = areaList[position]
        holder.name.text = user.name
        holder.owner.text = user.owner.toString()
    }

    override fun getItemCount() = areaList.size
}