package org.brynhild.graduation.network.adapter

import android.content.Context
import android.content.Intent
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.google.gson.Gson
import org.brynhild.graduation.R
import org.brynhild.graduation.activity.admin.ClassDetailInfoActivity
import org.brynhild.graduation.common.config.MyApplication
import org.brynhild.graduation.network.entiity.ClassEntity

class ClassEntityAdapter(
    private val context: Context,
    private val classEntityList: List<ClassEntity>
) :
    RecyclerView.Adapter<ClassEntityAdapter.ViewHolder>() {

    inner class ViewHolder(view: View) : RecyclerView.ViewHolder(view) {
        val name: TextView = view.findViewById(R.id.name)
        val no: TextView = view.findViewById(R.id.no)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.class_item, parent, false)
        val holder = ViewHolder(view)
        holder.itemView.setOnClickListener {
            val position = holder.adapterPosition
            val classEntity = classEntityList[position]
            val intent = Intent(MyApplication.context, ClassDetailInfoActivity::class.java)
            intent.flags = Intent.FLAG_ACTIVITY_NEW_TASK
            val gson = Gson()
            intent.putExtra("class", gson.toJson(classEntity))
            MyApplication.context.startActivity(intent)
        }
        return holder
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val user = classEntityList[position]
        holder.name.text = user.name
        holder.no.text = user.no
    }

    override fun getItemCount() = classEntityList.size
}