package org.brynhild.graduation.network.adapter

import android.content.Context
import android.content.Intent
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.google.gson.Gson
import org.brynhild.graduation.R
import org.brynhild.graduation.activity.admin.CourseDetailInfoActivity
import org.brynhild.graduation.common.config.MyApplication
import org.brynhild.graduation.network.entiity.Course

class CourseAdapter(private val context: Context, private val courseList: List<Course>) :
    RecyclerView.Adapter<CourseAdapter.ViewHolder>() {

    inner class ViewHolder(view: View) : RecyclerView.ViewHolder(view) {
        val name: TextView = view.findViewById(R.id.name)
        val department: TextView = view.findViewById(R.id.department)
        val credit: TextView = view.findViewById(R.id.credit)
        val period: TextView = view.findViewById(R.id.period)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.course_item, parent, false)
        val holder = ViewHolder(view)
        holder.itemView.setOnClickListener {
//            val position = holder.adapterPosition
//            val course = courseList[position]
//            val intent = Intent(MyApplication.context, CourseDetailInfoActivity::class.java)
//            intent.flags = Intent.FLAG_ACTIVITY_NEW_TASK
//            val gson = Gson()
//            intent.putExtra("course", gson.toJson(course))
//            MyApplication.context.startActivity(intent)
        }
        return holder
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val major = courseList[position]
        holder.name.text = major.name
        holder.department.text = "${major.department}"
        holder.credit.text = "${major.credit}"
        holder.period.text = major.period
    }

    override fun getItemCount() = courseList.size
}