package org.brynhild.graduation.network.adapter

import android.content.Context
import android.content.Intent
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.google.gson.Gson
import org.brynhild.graduation.R
import org.brynhild.graduation.activity.admin.MajorDetailInfoActivity
import org.brynhild.graduation.common.config.MyApplication
import org.brynhild.graduation.network.entiity.Major

class MajorAdapter(private val context: Context, private val majorList: List<Major>) :
    RecyclerView.Adapter<MajorAdapter.ViewHolder>() {

    inner class ViewHolder(view: View) : RecyclerView.ViewHolder(view) {
        val name: TextView = view.findViewById(R.id.name)
        val no: TextView = view.findViewById(R.id.no)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.major_item, parent, false)
        val holder = ViewHolder(view)
        holder.itemView.setOnClickListener {
            val position = holder.adapterPosition
            val major = majorList[position]
            val intent = Intent(MyApplication.context, MajorDetailInfoActivity::class.java)
            intent.flags = Intent.FLAG_ACTIVITY_NEW_TASK
            val gson = Gson()
            intent.putExtra("major", gson.toJson(major))
            MyApplication.context.startActivity(intent)
        }
        return holder
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val major = majorList[position]
        holder.name.text = major.name
        holder.no.text = major.code
    }

    override fun getItemCount() = majorList.size
}