package org.brynhild.graduation.network.adapter

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import org.brynhild.graduation.R
import org.brynhild.graduation.network.entiity.SignInRecord

class SignInRecordAdapter(
    private val context: Context,
    private val recordList: List<SignInRecord>
) :
    RecyclerView.Adapter<SignInRecordAdapter.ViewHolder>() {

    inner class ViewHolder(view: View) : RecyclerView.ViewHolder(view) {
        val areaName: TextView = view.findViewById(R.id.areaName)
        val time: TextView = view.findViewById(R.id.time)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.sign_in_record_item, parent, false)
        return ViewHolder(view)
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val user = recordList[position]
        holder.areaName.text = user.areaName
        holder.time.text = user.time
    }

    override fun getItemCount() = recordList.size
}