package org.brynhild.graduation.network.adapter

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.bumptech.glide.Glide
import org.brynhild.graduation.R
import org.brynhild.graduation.network.entiity.User

class UserAdapterUsingByTeacher(private val context: Context, private val userList: List<User>) :
    RecyclerView.Adapter<UserAdapterUsingByTeacher.ViewHolder>() {

    inner class ViewHolder(view: View) : RecyclerView.ViewHolder(view) {
        val avatar: ImageView = view.findViewById(R.id.avatar)
        val name: TextView = view.findViewById(R.id.name)
        val no: TextView = view.findViewById(R.id.no)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.user_item, parent, false)
        val holder = ViewHolder(view)
//        holder.itemView.setOnClickListener {
//            val position = holder.adapterPosition
//            val user = userList[position]
//            val intent = Intent(MyApplication.context, UserDetailInfoActivity::class.java)
//            intent.flags = Intent.FLAG_ACTIVITY_NEW_TASK
//            val gson = Gson()
//            intent.putExtra("user", gson.toJson(user))
//            MyApplication.context.startActivity(intent)
//        }
        return holder
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val user = userList[position]
        holder.name.text = user.name
        holder.no.text = user.no
        Glide.with(context).load(user.avatar ?: R.drawable.nav_user).into(holder.avatar)
    }

    override fun getItemCount() = userList.size
}