package org.brynhild.graduation.network.entiity;


import com.zhuangfei.timetable.model.Schedule;
import com.zhuangfei.timetable.model.ScheduleEnable;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

public class TimeTableInfo implements ScheduleEnable {
    private Long id;
    private String name;
    private String room;
    private String teacher;
    private String week;
    private Integer start;
    private Integer step;
    private Integer day;

    @Override
    public Schedule getSchedule() {
        Schedule schedule = new Schedule();
        schedule.setDay(day);
        schedule.setName(name);
        schedule.setRoom(room);
        schedule.setStart(start);
        schedule.setStep(step);
        schedule.setTeacher(teacher);
        List<Integer> collect;
        if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.N) {
            collect = Arrays.stream(week.split(",")).map(Integer::parseInt).collect(Collectors.toList());
        } else {
            String[] split = week.split(",");
            collect = new ArrayList<>();
            for (String str : split) {
                collect.add(Integer.parseInt(str));
            }
        }
        schedule.setWeekList(collect);
        schedule.setColorRandom(2);
        return schedule;
    }
}
