package org.brynhild.graduation.service.http

import org.brynhild.graduation.common.constant.AccountConstant
import org.brynhild.graduation.common.transfer.Result
import org.brynhild.graduation.common.transfer.vo.*
import org.brynhild.graduation.common.transfer.vo.user.*
import retrofit2.Call
import retrofit2.http.*

interface AccountService {

    @POST("user/public/login")
    fun login(@Body info: AccountLoginInfo): Call<Result>

    @POST("user/public/register")
    fun accountRegister(@Body info: AccountRegisterInfo): Call<Result>

    @POST("user/public/resend")
    fun resendEmail(@Body info: ResendEmail): Call<Result>

    @POST("user/common/info")
    fun accountInfo(@Header(AccountConstant.ACCOUNT_HEADER) token: String): Call<Result>

    @PUT("user/common/info")
    fun modifyAccountInfo(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: ModifyAccountInfo
    ): Call<Result>

    @HTTP(method = "DELETE", path = "account", hasBody = true)
    fun deleteAccount(@Body info: AccountToken): Call<Result>

    @POST("account/forget")
    fun sendForgetEmail(@Body info: AccountName): Call<Result>

    @POST("account/reset")
    fun resetAccountByCode(@Body info: ResetPasswordByCode): Call<Result>
}