package org.brynhild.graduation.service.http

import org.brynhild.graduation.common.constant.AccountConstant
import org.brynhild.graduation.common.transfer.Result
import org.brynhild.graduation.common.transfer.vo.*
import org.brynhild.graduation.common.transfer.vo.device.*
import org.brynhild.graduation.common.transfer.vo.timetable.*
import org.brynhild.graduation.common.transfer.vo.user.*
import retrofit2.Call
import retrofit2.http.*

interface AdminService {

    @POST("user/admin/user")
    fun queryUser(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: QueryUserRequest
    ): Call<Result>

    @HTTP(method = "DELETE", path = "user/admin/user", hasBody = true)
    fun deleteUser(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminDeleteUser
    ): Call<Result>

    @POST("user/admin/user/add")
    fun addUser(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminAddUser
    ): Call<Result>

    @PUT("user/admin/user")
    fun modifyUser(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminModifyUser
    ): Call<Result>


    @POST("user/admin/academy")
    fun queryAcademy(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: QueryAcademyRequest
    ): Call<Result>

    @HTTP(method = "DELETE", path = "user/admin/academy", hasBody = true)
    fun deleteAcademy(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminDeleteAcademy
    ): Call<Result>

    @POST("user/admin/academy/add")
    fun addAcademy(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminAddAcademy
    ): Call<Result>

    @PUT("user/admin/academy")
    fun modifyAcademy(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminModifyAcademy
    ): Call<Result>


    @POST("user/admin/major")
    fun queryMajor(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: QueryMajorRequest
    ): Call<Result>

    @HTTP(method = "DELETE", path = "user/admin/major", hasBody = true)
    fun deleteMajor(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminDeleteMajor
    ): Call<Result>

    @POST("user/admin/major/add")
    fun addMajor(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminAddMajor
    ): Call<Result>

    @PUT("user/admin/major")
    fun modifyMajor(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminModifyMajor
    ): Call<Result>


    @POST("user/admin/class")
    fun queryClass(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: QueryClassRequest
    ): Call<Result>

    @HTTP(method = "DELETE", path = "user/admin/class", hasBody = true)
    fun deleteClass(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminDeleteClass
    ): Call<Result>

    @POST("user/admin/class/add")
    fun addClass(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminAddClass
    ): Call<Result>

    @PUT("user/admin/class")
    fun modifyClass(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminModifyClass
    ): Call<Result>


    @POST("device/admin/device")
    fun queryDevice(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: QueryDeviceRequest
    ): Call<Result>

    @HTTP(method = "DELETE", path = "device/admin/device", hasBody = true)
    fun deleteDevice(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminDeleteDevice
    ): Call<Result>

    @POST("device/admin/device/bind")
    fun addDevice(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: BindDevice
    ): Call<Result>

    @POST("device/admin/device/enroll")
    fun enrollFingerPrint(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: EnrollFingerPrint
    ): Call<Result>

    @PUT("device/admin/device")
    fun modifyDevice(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminModifyDevice
    ): Call<Result>


    @POST("device/admin/area")
    fun queryArea(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: QueryAreaRequest
    ): Call<Result>

    @HTTP(method = "DELETE", path = "device/admin/area", hasBody = true)
    fun deleteArea(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminDeleteArea
    ): Call<Result>

    @POST("device/admin/area/add")
    fun addArea(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminAddArea
    ): Call<Result>

    @PUT("device/admin/area")
    fun modifyArea(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminModifyArea
    ): Call<Result>

    @POST("device/admin/batch/finger")
    fun getClassFingerPrintDataIdList(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminGetClassFingerPrintDataIdList
    ): Call<Result>

    @POST("device/admin/batch/clear")
    fun clearFingerPrintDataAtDevice(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminClearFingerPrintDataAtDevice
    ): Call<Result>

    @POST("device/admin/batch/push")
    fun pushFingerPrintDataToDevice(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminPushFingerPrintDataToDevice
    ): Call<Result>


    @POST("device/admin/signInRecord")
    fun querySignInRecord(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: QuerySignInRecordRequest
    ): Call<Result>


    @POST("timetable/admin/course")
    fun queryCourse(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: QueryCourseRequest
    ): Call<Result>

    @HTTP(method = "DELETE", path = "timetable/admin/course", hasBody = true)
    fun deleteCourse(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminDeleteCourse
    ): Call<Result>

    @POST("timetable/admin/course/add")
    fun addCourse(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminAddCourse
    ): Call<Result>

//    @PUT("timetable/admin/course")
//    fun modifyCourse(@Header(AccountConstant.ACCOUNT_HEADER)token: String,@Body info: AdminModifyCourse):Call<Result>


    @POST("timetable/admin/timetable")
    fun queryTimeTable(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: QueryTimeTableRequest
    ): Call<Result>

    @HTTP(method = "DELETE", path = "timetable/admin/timetable", hasBody = true)
    fun deleteTimeTable(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminDeleteTimeTable
    ): Call<Result>

    @POST("timetable/admin/timetable/add")
    fun addTimeTable(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminAddTimeTable
    ): Call<Result>


}