package org.brynhild.graduation.service.http

import org.brynhild.graduation.common.constant.AccountConstant
import org.brynhild.graduation.common.transfer.Result
import org.brynhild.graduation.common.transfer.vo.timetable.AdminQueryClassStatistic
import org.brynhild.graduation.common.transfer.vo.timetable.AdminQueryStudentStatistic
import retrofit2.Call
import retrofit2.http.Body
import retrofit2.http.GET
import retrofit2.http.Header
import retrofit2.http.POST

interface CommonService {

    @GET("timetable/public/config")
    fun loadTimeTableConfig(): Call<Result>

    @POST("timetable/public/statistic/class")
    fun queryClassStatistic(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminQueryClassStatistic
    ): Call<Result>

    @POST("timetable/public/statistic/student")
    fun queryStudentStatistic(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminQueryStudentStatistic
    ): Call<Result>

    @POST("timetable/public/statistic/class/generate")
    fun generateClassStatistic(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminQueryClassStatistic
    ): Call<Result>

    @POST("timetable/public/statistic/student/generate")
    fun generateStudentStatistic(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: AdminQueryStudentStatistic
    ): Call<Result>
}