package org.brynhild.graduation.service.http

import org.brynhild.graduation.common.constant.AccountConstant
import org.brynhild.graduation.common.transfer.Result
import org.brynhild.graduation.common.transfer.vo.timetable.QueryTeachingClassRequest
import org.brynhild.graduation.common.transfer.vo.timetable.QueryTeachingCourseStatisticRequest
import org.brynhild.graduation.common.transfer.vo.timetable.QueryTimeTableRequest
import org.brynhild.graduation.common.transfer.vo.user.QueryUserRequest
import retrofit2.Call
import retrofit2.http.Body
import retrofit2.http.Header
import retrofit2.http.POST

interface TeacherService {

    @POST("timetable/teacher/timetable")
    fun queryTimeTable(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: QueryTimeTableRequest
    ): Call<Result>

    @POST("timetable/teacher/clazz")
    fun queryTeachingClass(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: QueryTeachingClassRequest
    ): Call<Result>

    @POST("user/teacher/user")
    fun queryUser(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: QueryUserRequest
    ): Call<Result>

    @POST("timetable/teacher/statistic")
    fun queryTeachingCourseStatistic(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: QueryTeachingCourseStatisticRequest
    ): Call<Result>

    @POST("timetable/teacher/statistic/generate")
    fun generateTeachingCourseStatistic(
        @Header(AccountConstant.ACCOUNT_HEADER) token: String,
        @Body info: QueryTeachingCourseStatisticRequest
    ): Call<Result>
}