package org.brynhild.graduation.service.mqtt

import android.app.Service
import android.content.Intent
import android.os.Binder
import android.os.IBinder
import android.util.Log
import org.brynhild.graduation.common.config.LoginConfiguration
import org.brynhild.graduation.common.config.MqttServerConfig
import org.brynhild.graduation.common.config.MyApplication

class MqttListenService : Service() {
    val TAG = MqttListenService::class.java.simpleName

    override fun onCreate() {
        super.onCreate()
        Log.e(TAG, "onCreate")
        init()
    }

    override fun onDestroy() {
        stopSelf()
        super.onDestroy()
    }

    private fun init() {
        println("ListenService创建")
        MyApplication.serviceContext = this
        val clientId = MqttServerConfig.getClientId() ?: ""
        val client = SubscribeClient(clientId)
        client.subscribe()
        client.publish(LoginConfiguration.userInfo!!.token)
    }

    override fun onBind(intent: Intent): IBinder {
        Log.e(TAG, "onBind")
        return CustomBinder()
    }

    inner class CustomBinder : Binder() {
        fun getService(): MqttListenService {
            return this@MqttListenService
        }
    }
}