package org.brynhild.graduation.service.mqtt;

import com.google.gson.Gson;

import org.eclipse.paho.client.mqttv3.IMqttDeliveryToken;
import org.eclipse.paho.client.mqttv3.MqttCallback;
import org.eclipse.paho.client.mqttv3.MqttMessage;

// 发布/订阅消息的回调类
public class PushCallback implements MqttCallback {


    // 客户端ID
    private String clientId = "";


    // 构造方法
    public PushCallback(String clientId) {
        this.clientId = clientId;
    }


    // 在断开连接时调用
    @Override
    public void connectionLost(Throwable throwable) {
        throwable.printStackTrace();
        System.out.println(this.clientId + "连接已断开！");
    }


    // 接收订阅主题消息的回调
    @Override
    public void messageArrived(String topic, MqttMessage message) throws Exception {

        System.out.println("接收消息主题 : " + topic);
        System.out.println("接收消息Qos : " + message.getQos());
        System.out.println("接收消息内容 : " + new String(message.getPayload(), "GBK"));
        String content = new String(message.getPayload(), "GBK");
        if (content.startsWith("{")) {
            Gson gson = new Gson();
            String channelId = "com.example.devicemanager.service";

        }
    }

    // 接收发布主题消息的回调
    @Override
    public void deliveryComplete(IMqttDeliveryToken token) {
        System.out.println("发布消息回调：" + token.isComplete());
    }

}
